/*
 * Sample Player using datatypes written by Marcin Juszkiewicz (Szczepan/BlaBla)
 *
 * I wrote this program nearly year ago and don't look in code by few months.
 * At now I can't remember which function do what etc. and I forgot how to use
 * EasyGUI (I started programming MUI).
 *
 * I give this source free to use. You can do whatever you want with it but:
 *
 * - the name "BlaBla Sample Player" or BSP is (C) by Szczepan/BlaBla (it's me)
 * - you can't release it as it is under other name without some credits about me
 * - you can use any part of code in any of your program
 * - I don't give any warranty for this program but it works good for me and others
 *
 *
 * Few words about source.
 *
 * I use GoldED 4.7.3 as editor with TAB set to 4. All comments are in Polish
 * and I don't want to translate them.
 *
 * PROC dane is made for folding all history of program.
 * PROC definicje itp. is made for folding all DEFs etc.
 *
 *
PROC dane
 *
 * BlaBla Sample Player
 *
 * Odtwarza sample uywajc datatypw
 *
 * wersja 2.7
 * obsluga bledow zrobiona
 *
 * wersja 2.9
 * shortcut "q" dziaa !!! (dziki jakiemu gociowi z amigae LIST)
 *
 * wersja 3.0 (14.05.98)
 *
 * Save = Save as 8SVX
 * Dodany Time gadget - z aktualizacja przy zmianie end
 * End slider zawsze na koncu
 * Freq slider mnozony przez 2
 *
 * 3.1 (19.06.98)
 *
 * - file_req() - dodane (un)blockwin()
 * - about() - j.w.
 * - dodany BARLABEL w menu
 *
 * 3.2 (25.06.98)
 *
 * - file_req_dt() - dodany hook na tylko dwiki - z colourlocka
 *
 * (22.07.98)
 *
 * - bugraport Siumota wzity pod uwag
 *   - dodany PUB=PUBSCREEN/K - dowolny ekran
 *   - napis na belce jest.
 *   - najpierw otwieram GUI potem pytam o nazw
 *   - "Save As" blokowane przy nieznanych
 * - filerequester otwiera si na tym ekranie co GUI
 *
 *
 *  TO DO
 * - wyczanie filtra
 *
 *
ENDPROC
*/

OPT OSVERSION = 37,
    PREPROCESS,
    LARGE

#define VERSTRING '$VER: BlaBla Sample Player 3.4 (13.06.98) by Szczepan/BlaBla'

/*
PROC definicje itp
 */


->#define DEBUG

MODULE 'tools/EasyGUI',         'tools/exceptions',

       'devices/timer',         'devices/audio',

       'graphics/gfxbase',      'dos/dos',
       'exec/memory',           'exec/nodes',
       'exec/io',               'exec/ports',    
       'asl',                   'libraries/asl',
       'workbench/workbench',   'workbench/startup',
       'datatypes',             'datatypes/datatypes',
       'datatypes/soundclass',  'datatypes/datatypesclass',
       'gadtools',              'libraries/gadtools',
       'tools/inithook',        'utility/hooks',
       'dos/dosasl',            'intuition/classes',

       'plugins/iconify'


ENUM ERR_NONE,ERR_NO_ASL,ERR_ALLOC,ERR_NO_PORT,ERR_NO_DTLIB,ERR_NO_TIMER,ERR_NO_IO,ERR_EXIT

ENUM WSIO_OK,NO_ASL_LIBRARY,NO_REQUESTER,NO_DATATYPES_LIB,NO_FILE_LOCK,NO_DATATYPE,
     OUT_OF_MEMORY,DTYPE_FAILED,NO_IFFPARSE_LIB,NO_IFFHANDLE,IFF_ERROR,PALETTE_NOT_FOUND,
     DATATYPE_ERROR,NO_SCREENLOCK,SYSTEM_TOO_OLD,NO_ICON_LIB,MULTICOLOR_PIC

ENUM NO_FILE,IFF_FILE,OTHER_FILE  /* typy plikw (wynik funkcji check_datatype()) */


-> Zmienne programu

DEF iconify       : PTR TO iconify,
    req           : PTR TO filerequester,
    filename[256] : STRING,
    typestr [20]  : STRING,
    error   [64]  : STRING,
    timestr [11]  : STRING,
    niegraj       = TRUE,
    pt            = TRUE,
    volume        = 64,
    mnoznik       = 1,
    frequency,
    period,
    start,
    end,
    len

DEF file_text,       type_text,
    end_slider,      end_int,
    freq_slider,     freq_int,
    volume_slider,   volume_int,
    load_but,        len_numb,
    play_but,        save_but,
    quit_but,        time_text

DEF gh : PTR TO guihandle

-> Datatypes

DEF sobj                 : PTR TO object,
    dt_timerequest = NIL : PTR TO timerequest, -> pointer TO a timerequest OBJECT
    dt_timeport    = NIL : PTR TO mp           -> messageport FOR timer.device

DEF scrlock = NIL

/*
ENDPROC
 */

PROC main() HANDLE

DEF myargs : PTR TO LONG,
    res    = -1,
    rdargs

  VOID VERSTRING

    myargs := [NIL,NIL]
    IF rdargs := ReadArgs('FILE,PUB=PUBSCREEN/K',myargs,NIL)
        IF myargs[NIL] THEN StrCopy(filename,myargs[NIL])
        IF myargs[1]
            scrlock := LockPubScreen(myargs[1])
        ENDIF
        FreeArgs(rdargs)
        IF StrLen(filename) = NIL THEN res := FALSE
    ELSE
        res := FALSE
    ENDIF

    init()

    guiinitA('BlaBla Sample Player',
        [ROWS,
            [PLUGIN,NIL,iconify],
            [BEVEL,
                [ROWS,
                    [COLS,
                        file_text := [TEXT,FilePart(filename),'File :',TRUE,4],
                        load_but  := [BUTTON,{but_load},'_Load...',NIL,"l",NIL,NIL]
                    ],
                    [COLS,
                        len_numb  := [NUM,len,'Lenght :',TRUE,8],
                        time_text := [TEXT,timestr,'Time :'  ,TRUE,8],
                        [SPACEH],
                        type_text := [TEXT,typestr,'Type :',TRUE,5],
                        [SPACEH]
                    ]
                ]
            ],
            [BEVEL,
                [COLS,
                    [EQROWS,
                        end_slider    := [SLIDE,{end2},  '_End :',   FALSE,1,end / mnoznik,end / mnoznik,5,'',1,"e",pt],
                        freq_slider   := [SLIDE,{freq2}, '_Freq :',  FALSE,1,32767,frequency,    5,'',1,"f",pt],
                        volume_slider := [SLIDE,{vol},   '_Volume :',FALSE,0,64,   volume,       5,'',1,"v",pt]
                    ],
                    [EQROWS,
                        end_int    := [INTEGER,{end2},  '',end,      4,2,NIL,pt],
                        freq_int   := [INTEGER,{freq2}, '',frequency,4,2,NIL,pt],
                        volume_int := [INTEGER,{vol},   '',volume,   4,2,NIL,pt]
                    ]
                ]
            ],
            [BEVEL,
                [EQCOLS,
                    [SPACEH],
                    [SPACEH],
                    play_but := [SBUTTON,{but_play},'_Play',NIL,"p",NIL,niegraj],
                    quit_but := [SBUTTON,{but_quit},'_Quit',NIL,"q",NIL,FALSE],
                    save_but := [SBUTTON,{but_save},'_Save',NIL,"s",NIL,pt],
                    [SPACEH],
                    [SPACEH]
                ]
            ]
            ],[EG_GHVAR,{gh},
               EG_AWPROC,{awproc},
               EG_SCRN,scrlock,
               EG_MENU,
                    [NM_TITLE,0,'Project',    0 ,0,0,0,
                     NM_ITEM, 0,'Open...',   'o',0,0,{but_load},
                     NM_ITEM, 0,'Save As...','S',0,0,{but_save},
                     NM_ITEM, 0,NM_BARLABEL,  0 ,0,0,0,
                     NM_ITEM, 0,'About',     '?',0,0,{about},
                     NM_ITEM, 0,NM_BARLABEL,  0 ,0,0,0,
                     NM_ITEM, 0,'Quit',      'q',0,0,{but_quit},
                     NM_END,  0,0,            0,0,0,0]:newmenu,NIL
        ]
    )

    SetWindowTitles(gh.wnd,'BlaBla Sample Player','BlaBla Sample Player 3.3 (22.07.98) by Szczepan/BlaBla - BLABLA PRODUCT')

    IF res = FALSE THEN file_req_dt()
    IF filename    THEN laduj()

    res := -1
    WHILE res < NIL
        Wait(gh.sig)
        res := guimessage(gh)
    ENDWHILE

EXCEPT DO

    cleangui(gh)
    exit()

    IF exception
        SELECT exception
            CASE ERR_NO_IO
                StrCopy(error,'Could not create message port\n')
            CASE ERR_NO_DTLIB
                StrCopy(error,'Could not open datatypes.library\n')
            CASE ERR_NO_ASL
                StrCopy(error,'Could not open asl.library\n')
            CASE ERR_NO_TIMER
                StrCopy(error,'Could not open timer.device\n')
            CASE ERR_ALLOC
                StrCopy(error,'Could not allocate structure !\n')
            CASE ERR_NO_PORT
                StrCopy(error,'Could not create port !\n')
            CASE ERR_EXIT
                CleanUp(NIL)
            DEFAULT
                StrCopy(error,'Unknown error !\n')
        ENDSELECT
        show_error()
    ENDIF
    CleanUp(NIL)

ENDPROC

PROC init()

    IF (aslbase := OpenLibrary('asl.library',38)) = NIL THEN Raise(ERR_NO_ASL)

    req := AllocAslRequest(ASL_FILEREQUEST,
                          [ASL_HAIL,'Select file',
                           ASLFR_SCREEN,scrlock,
                           NIL])
    IF req = NIL THEN Raise(ERR_ALLOC)

-> Datatypes

    IF (datatypesbase  := OpenLibrary('datatypes.library',39))=NIL THEN Raise(ERR_NO_DTLIB)
    IF (dt_timeport    := CreateMsgPort())=NIL THEN Raise(ERR_NO_PORT)
    IF (dt_timerequest := CreateIORequest(dt_timeport,SIZEOF timerequest))=NIL THEN Raise(ERR_NO_IO)
    IF OpenDevice('timer.device',UNIT_VBLANK,dt_timerequest,NIL)<>NIL THEN Raise(ERR_NO_TIMER)

    NEW iconify.create('BSP','ENV:sys/def_BlaBla')

ENDPROC
PROC exit()

    IF req           THEN FreeAslRequest(req)
    IF aslbase       THEN CloseLibrary(aslbase)

-> datatypes

    IF dt_timerequest
        IF dt_timerequest::io.device THEN CloseDevice(dt_timerequest)
        DeleteIORequest(dt_timerequest)
    ENDIF
    IF sobj          THEN DisposeDTObject(sobj)
    IF dt_timeport   THEN DeleteMsgPort(dt_timeport)
    IF datatypesbase THEN CloseLibrary(datatypesbase)

    END iconify

ENDPROC
PROC about()

    blockwin(gh)
    EasyRequestArgs(NIL,[20,NIL,'BlaBla Sample Player','BlaBla Sample Player 3.3 (22.07.98)\nby Szczepan/BlaBla.\n\nThis is BLABLA PRODUCT !\n(see docs for more info)\n\nThis program is GiftWare\n\nBugreports are very welcome.\n\nE-mail : szczepan@student.man.bialystok.pl\nWWW : http://student.man.bialystok.pl/szczepan/','Ok'],NIL,NIL)
    unblockwin(gh)

ENDPROC
PROC show_error()

    EasyRequestArgs(NIL,[20,NIL,'Information',error,'Ok'],NIL,NIL)

ENDPROC

PROC end2(a,b,info,cur)

-> b = typ gadgetu (data)


    IF b = 1 THEN end := cur * mnoznik
    IF b = 2
        IF cur > len THEN cur := len
        IF cur < 2   THEN cur := 2
        end := cur
    ENDIF

#ifdef DEBUG
    WriteF('end : \d\n',end)
#endif

    render_sliders()
    SetDTAttrsA(sobj,NIL,NIL,[SDTA_SAMPLELENGTH,end - start,NIL])
    settime(end - start)

ENDPROC
PROC freq2(a,b,info,cur)

    IF b = 1 THEN frequency := cur * 2
    IF b = 2
        IF cur > 65535 THEN cur := 65535
        IF cur < 1     THEN cur := 1
        frequency := cur
    ENDIF

#ifdef DEBUG
    WriteF('freq : \d\n',cur)
#endif

    setslide(gh,freq_slider,frequency / 2)
    setinteger(gh,freq_int,frequency)
    SetDTAttrsA(sobj,NIL,NIL,[SDTA_PERIOD,Div(3546895,frequency),NIL])
    settime(end)

ENDPROC
PROC vol(a,b,info,cur)

    IF cur > 64  THEN cur := 64
    IF cur < NIL THEN cur := NIL

    volume := cur

#ifdef DEBUG
    WriteF('vol : \d\n',cur)
#endif

    setslide(gh,volume_slider,cur)
    setinteger(gh,volume_int,cur)
    SetDTAttrsA(sobj,NIL,NIL,[SDTA_VOLUME,cur,NIL])

ENDPROC
PROC but_load()

    file_req_dt()
    IF filename THEN laduj()

ENDPROC
PROC but_play()

#ifdef DEBUG
    WriteF('Play BUTTON Pressed\n')
#endif

    IF sobj
        IF period
            blockwin(gh)
            dt_timerequest.time::timeval.secs  := Div(end,frequency)
            dt_timerequest.time::timeval.micro := Mul(Div(1000000,frequency),Mod(end,frequency))
            dt_timerequest::io.command         := TR_ADDREQUEST
            SendIO(dt_timerequest)
            DoDTMethodA(sobj,NIL,NIL,[DTM_TRIGGER,NIL,STM_PLAY,NIL])
            Wait(Shl(1,dt_timeport::mp.sigbit))
            WaitIO(dt_timerequest)
            unblockwin(gh)
        ENDIF
    ENDIF

ENDPROC
PROC but_save()

DEF file

    file_req()

    blockwin(gh)
    IF StrLen(filename) > NIL
        IF FileLength(filename) > -1
            IF EasyRequestArgs(NIL,[20,NIL,'Warning','File already exist !!!','Overwrite|Cancel'],NIL,NIL)
            ELSE
                RETURN
            ENDIF
        ENDIF

        file := Open(filename,NEWFILE)
        DoDTMethodA(sobj,NIL,NIL,[DTM_WRITE,NIL,file,DTWM_IFF,NIL])
        Close(file)
    ENDIF
    unblockwin(gh)

ENDPROC
PROC but_quit()

    Raise(ERR_EXIT)

ENDPROC
PROC render_sliders()

    IF end < 2   THEN end := 2
    IF end > len THEN end := len

    setinteger(gh,end_int,end)
    setslide(gh,end_slider,end / mnoznik)

ENDPROC
PROC settime(len)

DEF secs,
    micro,
    mins,
    hours

    IF period
        micro := Mul(Div(1000000,frequency),Mod(len,frequency))
        secs  := Div(len,frequency)
        hours := Abs(secs / 3600)
        secs  := secs - (hours * 3600)
        mins  := Abs(secs / 60)
        secs  := secs - (mins * 60)
        StringF(timestr,'\z\r\d[2]:\z\r\d[2]:\z\r\d[2].\z\r\d[2]\n',hours,mins,secs,micro)
        IF gh THEN settext(gh,time_text,timestr)
    ENDIF

ENDPROC

PROC laduj()

DEF dth     : PTR TO datatypeheader,
    dtn     : PTR TO datatype,
    sheader : PTR TO voiceheader,
    status  = FALSE,
    micro,
    secs,
    lock

    IF sobj THEN DisposeDTObject(sobj)

    blockwin(gh)
    IF (sobj := NewDTObjectA(filename,[DTA_SOURCETYPE,DTST_FILE,
                                       DTA_GROUPID,GID_SOUND,
                                       SDTA_VOLUME,volume,
                                       SDTA_CYCLES,1,
                                       NIL]))
        status   := TRUE
        niegraj  := FALSE
        IF (lock := Lock(filename, ACCESS_READ))
            IF (dtn := ObtainDataTypeA(DTST_FILE,lock,NIL)) -> Pobieram typ pliku
                dth := dtn.header
                StrCopy(typestr,dth.name)
                ReleaseDataType(dtn)
            ENDIF
            UnLock(lock)
        ENDIF
        IF GetDTAttrsA(sobj,[SDTA_SAMPLELENGTH,{len},
                             SDTA_VOICEHEADER,{sheader},
                             NIL])=2
            IF sheader
                period := sheader.samplespersec -> Jak ProTracker TO period i len = 0
                IF period
                    secs   := Div(len,period)
                    micro  := Mul(Div(1000000,period),Mod(len,period))
                    frequency := period
                    dt_timerequest.time::timeval.secs  := secs
                    dt_timerequest.time::timeval.micro := micro
                    pt := FALSE
                    settime(len)
                ELSE
                    frequency := NIL
                    volume    := NIL
                ENDIF
                IF (sobj) AND (status=FALSE) THEN DisposeDTObject(sobj) BUT sobj := NIL
                mnoznik := 1 + Abs(len / 32768)
                start   := NIL
                end     := len
            ENDIF
        ENDIF
        changemenus(gh,[NM_TITLE,0,'Project',    0 ,0,0,0,
                        NM_ITEM, 0,'Open...',   'o',0,0,{but_load},
                        NM_ITEM, 0,'Save As...','S',0,0,{but_save},
                        NM_ITEM, 0,NM_BARLABEL,  0 ,0,0,0,
                        NM_ITEM, 0,'About',     '?',0,0,{about},
                        NM_ITEM, 0,NM_BARLABEL,  0 ,0,0,0,
                        NM_ITEM, 0,'Quit',      'q',0,0,{but_quit},
                        NM_END,  0,0,            0,0,0,0]:newmenu)
    ELSE
        StrCopy(timestr,'??:??:??.??')
        StrCopy(typestr,'????')
        niegraj := TRUE
        len     := NIL
        period  := NIL
        changemenus(gh,[NM_TITLE,0,'Project',    0 ,0,0,0,
                        NM_ITEM, 0,'Open...',   'o',0,0,{but_load},
                        NM_ITEM, 0,'Save As...','S',16,0,{but_save},
                        NM_ITEM, 0,NM_BARLABEL,  0 ,0,0,0,
                        NM_ITEM, 0,'About',     '?',0,0,{about},
                        NM_ITEM, 0,NM_BARLABEL,  0 ,0,0,0,
                        NM_ITEM, 0,'Quit',      'q',0,0,{but_quit},
                        NM_END,  0,0,            0,0,0,0]:newmenu)

    ENDIF
    unblockwin(gh)

    setdisabled(gh,play_but,niegraj)
    IF period
        status := FALSE
    ELSE
        status := TRUE
    ENDIF

    settext(gh,type_text,typestr)
    settext(gh,time_text,timestr)
    setnum(gh,len_numb,len)
    settext(gh,file_text,FilePart(filename))
    setinteger(gh,freq_int,frequency)
    setslide(gh,freq_slider,frequency / 2)
    setslidemax(gh,end_slider,len / mnoznik)

    render_sliders()

    setdisabled(gh,freq_int      ,status)
    setdisabled(gh,freq_slider   ,status)
    setdisabled(gh,end_int       ,status)
    setdisabled(gh,end_slider    ,status)
    setdisabled(gh,volume_int    ,status)
    setdisabled(gh,volume_slider ,status)
    setdisabled(gh,save_but      ,status)

ENDPROC sobj
PROC file_req()

    IF gh THEN blockwin(gh)
    IF AslRequest(req,NIL) = NIL
        filename[NIL] := NIL
    ELSE
        StrCopy(filename,req.drawer,ALL)
        AddPart(filename,req.file,256)
    ENDIF
    IF gh THEN unblockwin(gh)

ENDPROC
PROC file_req_dt()

DEF filter_hook : hook

    IF gh THEN blockwin(gh)

    inithook(filter_hook,{filter})
    IF (AslRequest (req,[ASLFR_TITLETEXT,'SELECT file',ASLFR_FILTERFUNC,filter_hook,NIL])=NIL)
        filename[NIL] := NIL
    ELSE
        StrCopy(filename,req.drawer,ALL)
        AddPart(filename,req.file,256)
    ENDIF

    IF gh THEN unblockwin(gh)

ENDPROC
PROC awproc(info,awmsg : PTR TO appmessage)

DEF wbarg : PTR TO wbarg,
    ktr

    wbarg := awmsg.arglist
    FOR ktr := 1 TO awmsg.numargs
        filename[NIL] := NIL
        NameFromLock(wbarg.lock,filename,256)
        AddPart(filename,wbarg.name,256)
        laduj()
    ENDFOR

ENDPROC

PROC check_datatype (filename) HANDLE

DEF dtype:PTR TO datatype,
    io_err,
    lock,
    type

    IF (lock  := Lock (filename,ACCESS_READ)) = NIL THEN Raise (NO_FILE_LOCK)
    IF (dtype := ObtainDataTypeA (DTST_FILE,lock,NIL)) = NIL THEN Raise (NO_DATATYPE)
    IF dtype.header.groupid = GID_SOUND
        type := OTHER_FILE
    ENDIF

EXCEPT DO

    IF dtype THEN ReleaseDataType (dtype)
    IF lock THEN UnLock (lock)

    SELECT exception
        CASE NO_FILE_LOCK
            WriteF('No file found')
            type :=  DTYPE_FAILED
        CASE NO_DATATYPE
            io_err := IoErr ()
            SELECT io_err
                CASE ERROR_NO_FREE_STORE
                    WriteF ('msg_out_of_memory')
                    type := DTYPE_FAILED
                CASE ERROR_OBJECT_NOT_FOUND
                    WriteF ('msg_open_failed')
                    type := DTYPE_FAILED
            ENDSELECT
    ENDSELECT

ENDPROC type
PROC filter (hook,req:PTR TO filerequester,apath:PTR TO anchorpath)

DEF buffer[200]:STRING,
    result

    IF apath.info.direntrytype > 0 THEN RETURN TRUE   /* katalogi przechodz */
    StrCopy (buffer,req.drawer,200)
    AddPart (buffer,apath.info.filename,200)
    result := check_datatype (buffer)

ENDPROC result

